ypinit.sh revision 31110
1#!/bin/sh
2#	$Id: ypinit.sh,v 1.3 1997/11/10 20:48:54 wpaul Exp $
3#
4# ypinit.sh - setup an master or slave server.
5# (Taken from OpenBSD and modified for FreeBSD.)
6#
7DOMAINNAME=/bin/domainname
8HOSTNAME=/bin/hostname
9YPWHICH=/usr/bin/ypwhich
10YPXFR=/usr/libexec/ypxfr
11YP_DIR=/var/yp
12MAKEDBM=/usr/sbin/yp_mkdb
13MAPLIST="master.passwd.byname master.passwd.byuid passwd.byname passwd.byuid \
14	 group.byname group.bygid hosts.byname hosts.byaddr services.byname \
15	 rpc.byname rpc.bynumber networks.byname networks.byaddr netgroup \
16	 netgroup.byuser netgroup.byhost netid.byname publickey.byname \
17	 bootparams ethers.byname ethers.byaddr amd.host mail.aliases \
18	 ypservers protocols.byname protocols.bynumber netmasks.byaddr"
19
20ERROR_EXISTS="NO"
21umask 077
22
23#set -xv
24
25ERROR=USAGE				# assume usage error
26
27if [ $# -eq 1 ]
28then
29	if [ $1 = "-m" ]		# ypinit -m
30	then
31		DOMAIN=`${DOMAINNAME}`
32		SERVERTYPE=MASTER
33		ERROR=
34	fi
35
36	if [ $1 = "-u" ]		# ypinit -u
37	then
38		DOMAIN=`${DOMAINNAME}`
39		SERVERTYPE=UPDATE
40		ERROR=
41	fi
42fi
43
44if [ $# -eq 2 ]
45then
46	if [ $1 = "-m" ]		# ypinit -m domainname
47	then
48		DOMAIN=${2}
49		SERVERTYPE=MASTER
50		ERROR=
51	fi
52
53	if [ $1 = "-s" ]		# ypinit -s master_server
54	then
55		DOMAIN=`${DOMAINNAME}`
56		SERVERTYPE=SLAVE
57		MASTER=${2}
58		ERROR=
59	fi
60
61	if [ $1 = "-u" ]		# ypinit -u domainname
62	then
63		DOMAIN=${2}
64		SERVERTYPE=UPDATE
65		ERROR=
66	fi
67fi
68
69if [ $# -eq 3 ]
70then
71	if [ $1 = "-s" ]		# ypinit -s master_server domainname
72	then
73		DOMAIN=${3}
74		SERVERTYPE=SLAVE
75		MASTER=${2}
76		ERROR=
77	fi
78fi
79
80if [ "${ERROR}" = "USAGE" ]; then
81	cat << \__usage 1>&2
82usage: ypinit -m [domainname]
83       ypinit -s master_server [domainname]
84       ypinit -u [domainname]
85
86The `-m' flag builds a master YP server, and the `-s' flag builds
87a slave YP server.  When building a slave YP server, `master_server'
88must be an existing, reachable YP server.
89The `-u' is for updating the ypservers map on a master server.
90__usage
91
92	exit 1
93fi
94
95# Check if domainname is set, don't accept an empty domainname
96if [ -z "${DOMAIN}" ]; then
97	cat << \__no_domain 1>&2
98The local host's YP domain name has not been set.  Please set it with
99the domainname(8) command or pass the domain as an argument to ypinit(8).
100__no_domain
101
102	exit 1
103fi
104
105# Check if hostname is set, don't accept an empty hostname
106HOST=`${HOSTNAME}`
107if [ -z "${HOST}" ]; then
108	cat << \__no_hostname 1>&2
109The local host's hostname has not been set.  Please set it with the
110hostname(8) command.
111__no_hostname
112
113	exit 1
114fi
115
116# Check if we have contact with master.
117# If we can't list the maps on the master, then we fake it with a
118# hard-coded list of maps. The FreeBSD ypxfr command will work even
119# if ypbind isn't running or if we are bound to ourselves instead of
120# the master (the slave should be bound to itself, but since it has
121# no maps yet, we can't get a maplist from it).
122if [ "${SERVERTYPE}" = "SLAVE" ];
123then
124	COUNT=`${YPWHICH} -d ${DOMAIN} -m 2>/dev/null | grep -i ${MASTER} | wc -l | tr -d " "`
125	if [ "$COUNT" = "0" ]
126	then
127		echo "Can't enumerate maps from ${MASTER}. Please check that it is running." 1>&2
128		echo "Note: using hardcoded maplist for map transfers." 1>&2
129		YPMAPLIST=${MAPLIST}
130	else
131		YPMAPLIST=`${YPWHICH} -d ${DOMAIN} -m | cut -d\  -f1`
132	fi
133	echo "" 1>&2
134fi
135
136# Check if user is root
137ID=`id -u`
138if [ "${ID}" != "0" ]; then
139	echo "You have to be the superuser to run this.  Please login as root." 1>&2
140	exit 1
141fi
142
143# Check if the YP directory exists.
144
145if [ ! -d ${YP_DIR} -o -f ${YP_DIR} ]
146then
147	echo "The directory ${YP_DIR} doesn't exist.  Restore it from the distribution." 1>&2
148	exit 1
149
150fi
151
152echo -n "Server Type: ${SERVERTYPE} Domain: ${DOMAIN}"
153if [ "${SERVERTYPE}" = "SLAVE" ]; then
154	echo -n " Master: ${MASTER}"
155fi
156echo ""
157
158if [ "${SERVERTYPE}" != "UPDATE" ];
159then
160	cat << \__notice1
161
162Creating an YP server will require that you answer a few questions.
163Questions will all be asked at the beginning of the procedure.
164
165__notice1
166
167	echo -n "Do you want this procedure to quit on non-fatal errors? [y/n: n]  "
168	read DOEXIT
169
170	case ${DOEXIT} in
171	y*|Y*)
172		ERROR_EXIT="YES"
173		;;
174
175	*)	ERROR_EXIT="NO"
176		echo ""
177		echo "Ok, please remember to go back and redo manually whatever fails."
178		echo "If you don't, something might not work. "
179		;;
180	esac
181
182	if [ -d "${YP_DIR}/${DOMAIN}" ]; then
183		echo ""	
184		echo -n "Can we destroy the existing ${YP_DIR}/${DOMAIN} and its contents? [y/n: n]  "
185		read KILL
186
187		ERROR=
188		case ${KILL} in
189		y*|Y*)
190			ERROR="DELETE"
191			;;
192
193		*)	ERROR=
194			;;
195		esac
196
197		if [ "${ERROR}" = "DELETE" ]; then
198			if ! rm -rf ${YP_DIR}/${DOMAIN}; then
199				echo "Can't clean up old directory ${YP_DIR}/${DOMAIN}." 1>&2
200				exit 1
201			fi
202		else
203			echo "OK, please clean it up by hand and start again.  Bye"
204			exit 0
205		fi
206	
207	fi
208
209	if ! mkdir "${YP_DIR}/${DOMAIN}"; then
210		echo "Can't make new directory ${YP_DIR}/${DOMAIN}." 1>&2
211		exit 1
212	fi
213fi
214
215if [ "${SERVERTYPE}" = "MASTER" ];
216then
217
218	if [ ! -f ${YP_DIR}/Makefile ]
219	then
220		if [ ! -f ${YP_DIR}/Makefile.dist ]
221		then
222			echo "Can't find ${YP_DIR}/Makefile.dist. " 1>&2
223			exit 1
224		fi
225		cp ${YP_DIR}/Makefile.dist ${YP_DIR}/Makefile
226	fi
227
228fi
229
230if [ "${SERVERTYPE}" = "SLAVE" ];
231then
232
233	echo "There will be no further questions. The remainder of the procedure"
234	echo "should take a few minutes, to copy the databases from ${MASTER}."
235
236	for MAP in ${YPMAPLIST}
237	do
238		echo "Transfering ${MAP}..."
239		if ! ${YPXFR} -p ${YP_DIR} -h ${MASTER} -c -d ${DOMAIN} ${MAP}; then
240			echo "Can't transfer map ${MAP}." 1>&2
241			ERROR_EXISTS="YES"
242			if [ "${ERROR_EXIT}" = "YES" ]; then
243				exit 1
244			fi
245		fi
246	done
247
248	echo ""
249	if [ "${ERROR_EXISTS}" = "YES"  ]; then
250		echo "${HOST} has been setup as an YP slave server with errors. " 1>&2
251		echo "Please remember fix any problem that occurred." 1>&2
252	else
253		echo "${HOST} has been setup as an YP slave server without any errors. "
254	fi
255
256	echo "Don't forget to update map ypservers on ${MASTER}."
257	exit 0
258fi
259
260LIST_OK="NO"
261
262while [ "${LIST_OK}" = "NO" ];
263do
264	
265	if [ "${SERVERTYPE}" = "MASTER" ];
266	then
267		HOST_LIST="${HOST}"
268		echo ""
269		echo "At this point, we have to construct a list of this domains YP servers."
270		echo "${HOST} is already known as master server."
271		echo "Please continue to add any slave servers, one per line. When you are"
272		echo "done with the list, type a <control D>."
273		echo "	master server   :  ${HOST}"
274	fi
275
276	if [ "${SERVERTYPE}" = "UPDATE" ];
277	then
278		HOST_LIST="${HOST}"
279		NEW_LIST=""
280		MASTER_NAME=""
281		SHORT_HOST=`echo ${HOST} | cut -d. -f1`
282		if [ -f ${YP_DIR}/${DOMAIN}/ypservers ];
283		then
284			for srv in `${MAKEDBM} -u ${YP_DIR}/${DOMAIN}/ypservers | grep -v "^YP" | tr "\t" " " | cut -d\  -f1`;
285			do
286				short_srv=`echo ${srv} | cut -d. -f1`
287				if [ "${SHORT_HOST}" != "${short_srv}" ]
288				then
289					if [ "${NEW_LIST}" = "" ];
290					then
291						NEW_LIST="${srv}"
292					else
293						NEW_LIST="${NEW_LIST} ${srv}"
294					fi
295				fi
296			done;
297			MASTER_NAME=`${MAKEDBM} -u ${YP_DIR}/${DOMAIN}/ypservers | grep "^YP_MASTER_NAME" | tr "\t" " " | cut -d\  -f2`
298		fi
299		echo ""
300		echo "Update the list of hosts running YP servers in domain ${DOMAIN}."
301		echo "Master for this domain is ${MASTER_NAME}."
302		echo ""
303		echo "First verify old servers, type \\ to remove a server." 
304		echo "Then add new servers, one per line. When done type a <control D>." 
305		echo ""
306		echo "	master server   :  ${HOST}"
307		if [ "${NEW_LIST}" != "" ]; then
308			for node in $NEW_LIST; do
309				echo -n "	verify host     : [${node}] "
310				read verify
311				if [ "${verify}" != "\\" ]; then
312					HOST_LIST="${HOST_LIST} ${node}"
313				fi
314			done;
315		fi
316	fi
317
318	echo -n "	next host to add:  "
319
320	while read h
321	do
322		echo -n "	next host to add:  "
323		HOST_LIST="${HOST_LIST} ${h}"
324	done
325
326	echo ""
327	echo "The current list of NIS servers looks like this:"
328	echo ""
329
330	for h in `echo ${HOST_LIST}`;
331	do
332		echo ${h}
333	done
334
335	echo ""
336	echo -n "Is this correct?  [y/n: y]  "
337	read hlist_ok
338
339	case $hlist_ok in
340	n*)	echo "Let's try the whole thing again...";;
341	N*)	echo "Let's try the whole thing again...";;
342	*)	LIST_OK="YES";;
343	esac
344
345done
346
347echo "Building ${YP_DIR}/${DOMAIN}/ypservers..."
348rm -f ${YP_DIR}/ypservers
349touch -f ${YP_DIR}/ypservers
350rm -f ${YP_DIR}/${DOMAIN}/ypservers
351for host in ${HOST_LIST};
352do
353	echo "${host} ${host}" >> ${YP_DIR}/ypservers
354	echo "${host} ${host}"
355done | ${MAKEDBM} - ${YP_DIR}/${DOMAIN}/ypservers
356
357if [ $? -ne 0 ]; then
358	echo "" 1>&2
359	echo "Couldn't build yp data base ${YP_DIR}/${DOMAIN}/ypservers." 1>&2
360	ERROR_EXISTS="YES"
361	if [ "${ERROR_EXIT}" = "YES" ]; then 
362		exit 1
363	fi
364fi
365
366if [ "${SERVERTYPE}" = "MASTER" ]; then
367	
368	CUR_PWD=`pwd`
369	cd ${YP_DIR}
370	echo "Running ${YP_DIR}/Makefile..."
371	if ! make NOPUSH=True UPDATE_DOMAIN=${DOMAIN} YP_DIR=${YP_DIR}; then
372		echo "" 1>&2
373		echo "Error running Makefile." 1>&2
374		ERROR_EXISTS="YES"
375		if [ "${ERROR_EXIT}" = "YES" ]; then 
376			exit 1
377		fi
378	fi
379
380	cd ${CUR_PWD}
381
382	echo ""
383	if [ "${ERROR_EXISTS}" = "YES" ]; then
384		echo "${HOST} has been setup as an YP master server with errors. " 1>&2
385		echo "Please remember fix any problem that occurred." 1>&2
386	else
387		echo "${HOST} has been setup as an YP master server without any errors. "
388	fi
389
390fi
391